typedef Spe = {
	var spe : String;
	var nb : Int;
	var freq : Float;
}

class Faker {
	static var specialites : Array<Spe> = [
		{ spe : "SES", nb : 75, freq : 0.0 },
		{ spe : "Maths", nb : 150, freq : 0.0 },
		{ spe : "HGGSP", nb : 90, freq : 0.0 },
		{ spe : "HLP", nb : 75, freq : 0.0 },
		{ spe : "LLCE-Anglais", nb : 85, freq : 0.0 },
		{ spe : "Théâtre", nb : 19, freq : 0.0 },
		{ spe : "ArtsP", nb : 19, freq : 0.0 },
		{ spe : "NSI", nb : 40, freq : 0.0 },
		{ spe : "PC", nb : 100, freq : 0.0 },
		{ spe : "SVT", nb : 110, freq : 0.0 }
	];
	static var frequences : Array<Float> = [];

	static function obtenirSpecialite() : String {
		var alea = Math.random();
		var i = 0;
		for (freq in frequences) {
			if (alea < freq) break;
			i++;
		}
		return specialites[i].spe;
	}

	public static function main() {
		var nb = 0;
		for (spe in specialites) {
			nb += spe.nb;
		}
		var nbEleves = Math.round(nb / 3);

		var freq = 0.0;
		for (spe in specialites) {
			spe.freq = spe.nb / nb;
			freq += spe.freq;
			frequences.push(freq);
		}

		Sys.println("Nom,Prénom,Spé1,Spé2,Spé3,Spé3'");
		for (i in 1...nbEleves + 1) {
			var voeux = [];
			for (j in 0...4) {
				var spe = obtenirSpecialite();
				while (voeux.indexOf(spe) != -1) {
					spe = obtenirSpecialite();
				}
				voeux.push(spe);
			}
			Sys.println('Nom$i,Prénom$i,' + voeux.join(","));
		}
	}
}
